
package com.avaya.ipoffice.openapi.samples.adapter.jaxb;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlType;
import javax.xml.bind.annotation.XmlValue;
import javax.xml.bind.annotation.adapters.HexBinaryAdapter;
import javax.xml.bind.annotation.adapters.XmlJavaTypeAdapter;


/**
 * uses flattened structure - all types included here
 * 
 * <p>Java class for LocalDeviceID complex type.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * 
 * <pre>
 * &lt;complexType name="LocalDeviceID">
 *   &lt;simpleContent>
 *     &lt;extension base="&lt;http://www.ecma-international.org/standards/ecma-323/csta/ed4>DeviceIDType">
 *       &lt;attribute name="typeOfNumber" type="{http://www.ecma-international.org/standards/ecma-323/csta/ed4}typeOfNumberEnum" default="dialingNumber" />
 *       &lt;attribute name="mediaClass" type="{http://www.ecma-international.org/standards/ecma-323/csta/ed4}MediaClassAttribute" default="notKnown" />
 *       &lt;attribute name="connectionRate">
 *         &lt;simpleType>
 *           &lt;restriction base="{http://www.w3.org/2001/XMLSchema}long">
 *             &lt;minInclusive value="0"/>
 *           &lt;/restriction>
 *         &lt;/simpleType>
 *       &lt;/attribute>
 *       &lt;attribute name="bitRate" type="{http://www.ecma-international.org/standards/ecma-323/csta/ed4}bitRateEnum" default="constant" />
 *       &lt;attribute name="delayTolerance" type="{http://www.w3.org/2001/XMLSchema}long" />
 *       &lt;attribute name="switchingSubDomainCCIEType" type="{http://www.ecma-international.org/standards/ecma-323/csta/ed4}switchingSubDomainCCIETypeEnum" />
 *       &lt;attribute name="switchingSubDomainInformationElements">
 *         &lt;simpleType>
 *           &lt;restriction base="{http://www.w3.org/2001/XMLSchema}hexBinary">
 *           &lt;/restriction>
 *         &lt;/simpleType>
 *       &lt;/attribute>
 *     &lt;/extension>
 *   &lt;/simpleContent>
 * &lt;/complexType>
 * </pre>
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "LocalDeviceID", propOrder = {
    "value"
})
public class LocalDeviceID implements Serializable
{

    private final static long serialVersionUID = 1L;
    @XmlValue
    protected String value;
    @XmlAttribute
    protected TypeOfNumberEnum typeOfNumber;
    @XmlAttribute
    protected List<MediaClassComponents> mediaClass;
    @XmlAttribute
    protected Long connectionRate;
    @XmlAttribute
    protected BitRateEnum bitRate;
    @XmlAttribute
    protected Long delayTolerance;
    @XmlAttribute
    protected SwitchingSubDomainCCIETypeEnum switchingSubDomainCCIEType;
    @XmlAttribute
    @XmlJavaTypeAdapter(HexBinaryAdapter.class)
    protected byte[] switchingSubDomainInformationElements;

    /**
     * Gets the value of the value property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getValue() {
        return value;
    }

    /**
     * Sets the value of the value property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setValue(String value) {
        this.value = value;
    }

    /**
     * Gets the value of the typeOfNumber property.
     * 
     * @return
     *     possible object is
     *     {@link TypeOfNumberEnum }
     *     
     */
    public TypeOfNumberEnum getTypeOfNumber() {
        if (typeOfNumber == null) {
            return TypeOfNumberEnum.DIALING_NUMBER;
        } else {
            return typeOfNumber;
        }
    }

    /**
     * Sets the value of the typeOfNumber property.
     * 
     * @param value
     *     allowed object is
     *     {@link TypeOfNumberEnum }
     *     
     */
    public void setTypeOfNumber(TypeOfNumberEnum value) {
        this.typeOfNumber = value;
    }

    /**
     * Gets the value of the mediaClass property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the mediaClass property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getMediaClass().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link MediaClassComponents }
     * 
     * 
     */
    public List<MediaClassComponents> getMediaClass() {
        if (mediaClass == null) {
            mediaClass = new ArrayList<MediaClassComponents>();
        }
        return this.mediaClass;
    }

    /**
     * Gets the value of the connectionRate property.
     * 
     * @return
     *     possible object is
     *     {@link Long }
     *     
     */
    public Long getConnectionRate() {
        return connectionRate;
    }

    /**
     * Sets the value of the connectionRate property.
     * 
     * @param value
     *     allowed object is
     *     {@link Long }
     *     
     */
    public void setConnectionRate(Long value) {
        this.connectionRate = value;
    }

    /**
     * Gets the value of the bitRate property.
     * 
     * @return
     *     possible object is
     *     {@link BitRateEnum }
     *     
     */
    public BitRateEnum getBitRate() {
        if (bitRate == null) {
            return BitRateEnum.CONSTANT;
        } else {
            return bitRate;
        }
    }

    /**
     * Sets the value of the bitRate property.
     * 
     * @param value
     *     allowed object is
     *     {@link BitRateEnum }
     *     
     */
    public void setBitRate(BitRateEnum value) {
        this.bitRate = value;
    }

    /**
     * Gets the value of the delayTolerance property.
     * 
     * @return
     *     possible object is
     *     {@link Long }
     *     
     */
    public Long getDelayTolerance() {
        return delayTolerance;
    }

    /**
     * Sets the value of the delayTolerance property.
     * 
     * @param value
     *     allowed object is
     *     {@link Long }
     *     
     */
    public void setDelayTolerance(Long value) {
        this.delayTolerance = value;
    }

    /**
     * Gets the value of the switchingSubDomainCCIEType property.
     * 
     * @return
     *     possible object is
     *     {@link SwitchingSubDomainCCIETypeEnum }
     *     
     */
    public SwitchingSubDomainCCIETypeEnum getSwitchingSubDomainCCIEType() {
        return switchingSubDomainCCIEType;
    }

    /**
     * Sets the value of the switchingSubDomainCCIEType property.
     * 
     * @param value
     *     allowed object is
     *     {@link SwitchingSubDomainCCIETypeEnum }
     *     
     */
    public void setSwitchingSubDomainCCIEType(SwitchingSubDomainCCIETypeEnum value) {
        this.switchingSubDomainCCIEType = value;
    }

    /**
     * Gets the value of the switchingSubDomainInformationElements property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public byte[] getSwitchingSubDomainInformationElements() {
        return switchingSubDomainInformationElements;
    }

    /**
     * Sets the value of the switchingSubDomainInformationElements property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setSwitchingSubDomainInformationElements(byte[] value) {
        this.switchingSubDomainInformationElements = value;
    }

}
