
package com.avaya.ipoffice.openapi.samples.data;

import java.io.Serializable;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlSchemaType;
import javax.xml.bind.annotation.XmlType;
import javax.xml.datatype.XMLGregorianCalendar;


/**
 * <p>Java class for callLogEntry complex type.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * 
 * <pre>
 * &lt;complexType name="callLogEntry">
 *   &lt;complexContent>
 *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
 *       &lt;sequence>
 *         &lt;element name="id" type="{http://www.w3.org/2001/XMLSchema}unsignedInt"/>
 *         &lt;element name="monitorCrossRefID" type="{http://www.w3.org/2001/XMLSchema}string"/>
 *         &lt;element name="device" type="{http://www.ecma-international.org/standards/ecma-323/csta/ed4}DeviceID"/>
 *         &lt;element name="call_type" type="{http://calllog.common.avaya.com/}callType"/>
 *         &lt;element name="state" type="{http://calllog.common.avaya.com/}logEntryState"/>
 *         &lt;element name="number_of_calls" type="{http://www.w3.org/2001/XMLSchema}int"/>
 *         &lt;element name="call_timestamp" type="{http://www.w3.org/2001/XMLSchema}dateTime"/>
 *         &lt;element name="dialback_number" type="{http://www.w3.org/2001/XMLSchema}string"/>
 *         &lt;element name="calling_party_name" type="{http://www.w3.org/2001/XMLSchema}string"/>
 *         &lt;element name="tag" type="{http://www.w3.org/2001/XMLSchema}string"/>
 *         &lt;element name="duration" type="{http://www.w3.org/2001/XMLSchema}int"/>
 *         &lt;element name="isExternal" type="{http://www.w3.org/2001/XMLSchema}boolean"/>
 *       &lt;/sequence>
 *     &lt;/restriction>
 *   &lt;/complexContent>
 * &lt;/complexType>
 * </pre>
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "callLogEntry", propOrder = {
    "id",
    "monitorCrossRefID",
    "device",
    "callType",
    "state",
    "numberOfCalls",
    "callTimestamp",
    "dialbackNumber",
    "callingPartyName",
    "tag",
    "duration",
    "isExternal",
	"deviceName",
	"dialbackName",
	"otherEndAnonymousType"
})
@XmlRootElement
public class CallLogEntry implements Serializable
{

    private final static long serialVersionUID = 1L;
    @XmlElement(namespace = "")
    @XmlSchemaType(name = "unsignedInt")
    protected long id;
    @XmlElement(namespace = "", required = true)
    protected String monitorCrossRefID;
    @XmlElement(namespace = "", required = true)
    protected DeviceID device;
    @XmlElement(name = "call_type", namespace = "", required = true)
    protected CallType callType;
    @XmlElement(namespace = "", required = true)
    protected LogEntryState state;
    @XmlElement(name = "number_of_calls", namespace = "")
    protected int numberOfCalls;
    @XmlElement(name = "call_timestamp", namespace = "", required = true)
    @XmlSchemaType(name = "dateTime")
    protected XMLGregorianCalendar callTimestamp;
    @XmlElement(name = "dialback_number", namespace = "", required = true)
    protected String dialbackNumber;
    @XmlElement(name = "calling_party_name", namespace = "", required = true)
    protected String callingPartyName;
    @XmlElement(namespace = "", required = true)
    protected String tag;
    @XmlElement(namespace = "")
    protected int duration;
    @XmlElement(namespace = "")
    protected boolean isExternal;
    protected transient TargetTypes target;
	@XmlElement(name = "deviceName", namespace = "")
    protected String deviceName;
	@XmlElement(name = "dialbackName", namespace = "")
    protected String dialbackName="";
	@XmlElement(name = "otherEndAnonymousType", namespace = "", required=false)
	public AnonymousEndPointType otherEndAnonymousType=AnonymousEndPointType.NONE;
    
    
    public AnonymousEndPointType getOtherEndAnonymousType() {
		return otherEndAnonymousType;
	}

	public void setOtherEndAnonymousType(AnonymousEndPointType otherEndAnonymousType) {
		this.otherEndAnonymousType = otherEndAnonymousType;
	}

	public String getDialbackName() {
		return dialbackName;
	}

	public void setDialbackName(String dialbackName) {
		this.dialbackName = dialbackName;
	}

	public String getDeviceName() {
		return deviceName;
	}

	public void setDeviceName(String deviceName) {
		this.deviceName = deviceName;
	}

	public TargetTypes getTarget() {
        return target;
    }

    public void setTarget(TargetTypes value) {
        this.target = value;
    }

    /**
     * Gets the value of the id property.
     * 
     */
    public long getId() {
        return id;
    }

    /**
     * Sets the value of the id property.
     * 
     */
    public void setId(long value) {
        this.id = value;
    }

    /**
     * Gets the value of the monitorCrossRefID property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getMonitorCrossRefID() {
        return monitorCrossRefID;
    }

    /**
     * Sets the value of the monitorCrossRefID property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setMonitorCrossRefID(String value) {
        this.monitorCrossRefID = value;
    }

    /**
     * Gets the value of the device property.
     * 
     * @return
     *     possible object is
     *     {@link DeviceID }
     *     
     */
    public DeviceID getDevice() {
        return device;
    }

    /**
     * Sets the value of the device property.
     * 
     * @param value
     *     allowed object is
     *     {@link DeviceID }
     *     
     */
    public void setDevice(DeviceID value) {
        this.device = value;
    }

    /**
     * Gets the value of the callType property.
     * 
     * @return
     *     possible object is
     *     {@link CallType }
     *     
     */
    public CallType getCallType() {
        return callType;
    }

    /**
     * Sets the value of the callType property.
     * 
     * @param value
     *     allowed object is
     *     {@link CallType }
     *     
     */
    public void setCallType(CallType value) {
        this.callType = value;
    }

    /**
     * Gets the value of the state property.
     * 
     * @return
     *     possible object is
     *     {@link LogEntryState }
     *     
     */
    public LogEntryState getState() {
        return state;
    }

    /**
     * Sets the value of the state property.
     * 
     * @param value
     *     allowed object is
     *     {@link LogEntryState }
     *     
     */
    public void setState(LogEntryState value) {
        this.state = value;
    }

    /**
     * Gets the value of the numberOfCalls property.
     * 
     */
    public int getNumberOfCalls() {
        return numberOfCalls;
    }

    /**
     * Sets the value of the numberOfCalls property.
     * 
     */
    public void setNumberOfCalls(int value) {
        this.numberOfCalls = value;
    }

    /**
     * Gets the value of the callTimestamp property.
     * 
     * @return
     *     possible object is
     *     {@link XMLGregorianCalendar }
     *     
     */
    public XMLGregorianCalendar getCallTimestamp() {
        return callTimestamp;
    }

    /**
     * Sets the value of the callTimestamp property.
     * 
     * @param value
     *     allowed object is
     *     {@link XMLGregorianCalendar }
     *     
     */
    public void setCallTimestamp(XMLGregorianCalendar value) {
        this.callTimestamp = value;
    }

    /**
     * Gets the value of the dialbackNumber property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getDialbackNumber() {
        return dialbackNumber;
    }

    /**
     * Sets the value of the dialbackNumber property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setDialbackNumber(String value) {
        this.dialbackNumber = value;
    }

    /**
     * Gets the value of the callingPartyName property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getCallingPartyName() {
        return callingPartyName;
    }

    /**
     * Sets the value of the callingPartyName property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setCallingPartyName(String value) {
        this.callingPartyName = value;
    }

    /**
     * Gets the value of the tag property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getTag() {
        return tag;
    }

    /**
     * Sets the value of the tag property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setTag(String value) {
        this.tag = value;
    }

    /**
     * Gets the value of the duration property.
     * 
     */
    public int getDuration() {
        return duration;
    }

    /**
     * Sets the value of the duration property.
     * 
     */
    public void setDuration(int value) {
        this.duration = value;
    }

	/**
	 * @return the isExternal
	 */
	public boolean isExternal() {
		return isExternal;
	}

	/**
	 * @param isExternal the isExternal to set
	 */
	public void setExternal(boolean isExternal) {
		this.isExternal = isExternal;
	}

}
